
local function CreateStar(parent)
    local f = parent:CreateTexture(nil, "ARTWORK")
    f:SetTexture("Interface\\PetBattles\\PetJournal")
    f:SetTexCoord(0.11328125, 0.16210938, 0.02246094, 0.04687500)
    f:SetPoint("LEFT", parent, "LEFT", -4, 0)
    f:SetSize(16,16)
    return f
end

local groupMembers = {}
local function Update()
    if not GuildRosterContainer:IsShown() then
        return
    end
    local offset = HybridScrollFrame_GetOffset(GuildRosterContainer)
    local realmName = GetRealmName()

    wipe(groupMembers)

    if IsInGroup() then
        -- TODO only do party if group
        groupMembers[UnitName("player")] = true
        for i = 1,4 do
            local name, realm = UnitName("party"..i)
            if (not realm or realm == "" or realm == realmName) and name then
                groupMembers[name] = true
            end
        end
        for i = 1,40 do
            local name, realm = UnitName("raid"..i)
            if (not realm or realm == "" or realm == realmName) and name then
                groupMembers[name] = true
            end
        end
    end

    local i = 0
    while true do
        i = i + 1
        local frame = _G["GuildRosterContainerButton"..i]
        if not frame then
            break
        end

        if not frame._groupStar then
            frame.string1:SetPoint("LEFT", frame, "LEFT", 9, 0)
            frame._groupStar = CreateStar(frame)
        end

        local name = GetGuildRosterInfo(i + offset)
        if name and groupMembers[name] then
            frame._groupStar:Show()
        else
            frame._groupStar:Hide()
        end
    end
end

local frame = CreateFrame("FRAME")
frame:RegisterEvent("GROUP_ROSTER_UPDATED")
frame:RegisterEvent("PLAYER_ENTERING_WORLD")
frame:SetScript("OnEvent", Update)

hooksecurefunc("GuildRoster_Update", Update)
GuildRosterFrame:HookScript("OnShow", Update)
